Index: /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSDescriptive.java
===================================================================
--- /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSDescriptive.java	(revision 5944)
+++ /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSDescriptive.java	(revision 5945)
@@ -8,4 +8,5 @@
 
 import java.sql.SQLException;
+import java.sql.ResultSet;
 
 import org.w3c.dom.Document;
@@ -35,92 +36,90 @@
 
 public class METSDescriptive
-{	MultiMap map;
-	String   ID;
-	String   name;
-
-	public METSDescriptive(String ID, String name)
-	{	this.map  = new MultiMap();
-		this.ID   = ID;
-		this.name = name;
-	}
-
-	public String getID()
-	{	return this.ID;
-	}
-
-	public String getName()
-	{	return this.name;
-	}
-
-	public void addNamespace(METSNamespace namespace)
-	{	this.map.put(namespace.getName(), namespace);
-	}
-
-	public METSNamespace getNamespace(String namespace)
-	{	return (METSNamespace) this.map.get(namespace);
-	}
-
-	/**
-	 *  Get the version of a metadata namespace that can be used for
-	 *  adding new values to the document.  Remember, each namespace may
-	 *  occur more than once, but only one of the occurrences can be 'open'.
-	 *
-	 *  @param <code>String</code> the name of the namespace
-	 */
-	public METSNamespace getOpenNamespace(String namespace)
-	{	if (this.map.getAll(namespace) == null)
-		{ return null;
-		}
-
-		Iterator namespaces = ((List) this.map.getAll(namespace)).iterator();
-
-		while (namespaces.hasNext())
-		{	METSNamespace namespaceData = (METSNamespace) namespaces.next();
-
-			if (namespaceData.isEditable())
-			{	return namespaceData;
-			}
-		}
-		return null;
-	}
-
-	/**
-	 *  Add a piece of metadata to this document.  Existing values are preserved.
-	 *
-	 *  @param <code>String</code> the namespace in which the metadata occurs
-	 *  @param <code>String</code> the label of the metadata
-
-	 *  @param <code>String</code> the value of the metadata
-	 */
-	public void addMetadata(String namespace, String label, String value)
-	{ METSNamespace namespaceData = this.getOpenNamespace(namespace);
-
-		if (namespaceData == null ||
-				namespaceData.isEditable() == false) 
-		{	namespaceData = NamespaceFactory.initNamespace(namespace);
-			this.addNamespace(namespaceData);
-		}
-		namespaceData.addMetadata(label, value);
-	}
-
-	/**
-	 *  Add a piece of metadata to this document.  Existing values in editable
-	 *  parts of the document's metadata are destroyed.
-	 *
-	 *  @param <code>String</code> the namespace in which the metadata occurs
-	 *  @param <code>String</code> the label of the metadata
-
-	 *  @param <code>String</code> the value of the metadata
-	 */
-	public void setMetadata(String namespace, String label, String value)
-	{ METSNamespace namespaceData = this.getOpenNamespace(namespace);
-
-		if (namespaceData == null ||
-				namespaceData.isEditable() == false) 
-		{	namespaceData = NamespaceFactory.initNamespace(namespace);
-			this.addNamespace(namespaceData);
-		}
-		namespaceData.setMetadata(label, value);
-	}
+{ MultiMap map;
+  String   ID;
+  String   name;
+
+  public METSDescriptive(String ID, String name)
+  { this.map  = new MultiMap();
+    this.ID   = ID;
+    this.name = name;
+  }
+
+  public String getID()
+  { return this.ID;
+  }
+
+  public String getName()
+  { return this.name;
+  }
+
+  public void addNamespace(METSNamespace namespace)
+  { this.map.put(namespace.getName(), namespace);
+  }
+
+  public METSNamespace getNamespace(String namespace)
+  { return (METSNamespace) this.map.get(namespace);
+  }
+
+  /**
+   *  Get the version of a metadata namespace that can be used for
+   *  adding new values to the document.  Remember, each namespace may
+   *  occur more than once, but only one of the occurrences can be 'open'.
+   *
+   *  @param <code>String</code> the name of the namespace
+   */
+  public METSNamespace getOpenNamespace(String namespace)
+  { if (this.map.getAll(namespace) == null)
+    { return null;
+    }
+
+    Iterator namespaces = ((List) this.map.getAll(namespace)).iterator();
+
+    while (namespaces.hasNext())
+    { METSNamespace namespaceData = (METSNamespace) namespaces.next();
+
+      if (namespaceData.isEditable())
+      {	return namespaceData;
+      }
+    }
+    return null;
+  }
+  
+  /**
+   *  Add a piece of metadata to this document.  Existing values are preserved.
+   *
+   *  @param <code>String</code> the namespace in which the metadata occurs
+   *  @param <code>String</code> the label of the metadata   
+   *  @param <code>String</code> the value of the metadata
+   */
+  public void addMetadata(String namespace, String label, String value)
+  { METSNamespace namespaceData = this.getOpenNamespace(namespace);
+  
+    if (namespaceData == null ||
+	namespaceData.isEditable() == false) 
+    { namespaceData = NamespaceFactory.initNamespace(namespace);
+      this.addNamespace(namespaceData);
+    }
+    namespaceData.addMetadata(label, value);
+  }
+
+  /**
+   *  Add a piece of metadata to this document.  Existing values in editable
+   *  parts of the document's metadata are destroyed.
+   *
+   *  @param <code>String</code> the namespace in which the metadata occurs
+   *  @param <code>String</code> the label of the metadata   
+   *  @param <code>String</code> the value of the metadata
+   */
+  public void setMetadata(String namespace, String label, String value)
+  { METSNamespace namespaceData = this.getOpenNamespace(namespace);
+  
+    if (namespaceData == null ||
+	namespaceData.isEditable() == false) 
+    { namespaceData = NamespaceFactory.initNamespace(namespace);
+      this.addNamespace(namespaceData);
+    }
+    namespaceData.setMetadata(label, value);
+  }
 
 	/**
@@ -238,7 +237,7 @@
   }
 
-  public void writeSQL(DocumentInterface document, GS3SQLConnection connection)
+  public boolean writeSQL(DocumentInterface document, GS3SQLConnection connection)
   { // check if this node is in the
-    int sqlId = 0;
+    int sqlId = -1;
 
     //    System.out.println("Writing " + connection.toString());
@@ -253,31 +252,51 @@
 
     connection.execute(select.toString());
+
     try {
-	if (connection.getResultSet() != null &&
-	    connection.getResultSet().next()) {
-	    // the node already exists - no need to do anything as such
-	}
-	else
-	{
-	    // It is a new node and needs writing
-	    GS3SQLInsert insert = new GS3SQLInsert("metadata");
-	    insert.addValue("DocID", document.getID().toString());
-	    insert.addValue("MetaID", this.ID);
+      GS3SQLAction action;
+
+      ResultSet resultSet = connection.getResultSet();
+
+      if (resultSet != null &&
+	  resultSet.first()) {
+	// the node already exists - no need to do anything as such
+	GS3SQLUpdate update = new GS3SQLUpdate("metadata");
+	update.setWhere(where);
+	action = update;
+      }
+      else
+      { // Set result set to null, just in case next() didn't work above...
+	resultSet = null;
+
+	// It is a new node and needs writing
+	action = new GS3SQLInsert("metadata");
+
+	action.addValue("DocID", document.getID().toString());
+	action.addValue("MetaID", this.ID);
+      }
+	
+      // always set the group identifier
+      action.addValue("GroupID", this.name);
 	    
-	    connection.execute(insert.toString());
-	    
-	    // now execute the select statement again to get the new identifier
-	    // 'MetadataRef'
-	    //	    System.out.println(select.toString());
-	    connection.execute(select.toString());
-	}
-
-	// get the reference for this item...	
-	connection.getResultSet().first();
-	sqlId = connection.getResultSet().getInt("MetadataRef");
+      // execute the action as required
+      connection.execute(action.toString());
+
+      // create a new resultset if necessary
+      if (resultSet == null) {
+	// now execute the select statement again to get the new identifier
+	// 'MetadataRef'
+	// System.out.println(select.toString());
+	connection.execute(select.toString());
+
+	resultSet = connection.getResultSet();
+	resultSet.first();
+      }
+
+      // get the reference for this item...
+      sqlId = resultSet.getInt("MetadataRef");
     }
     catch (SQLException sql)
-	{ System.out.println(sql);
-	}
+    { System.out.println(sql);
+    }
 
     Iterator keys = this.map.keySet().iterator();
@@ -299,7 +318,58 @@
       { METSNamespace namespace = (METSNamespace) namespaces.next();
       
-        namespace.writeSQL(sqlId, connection);
-      }
-    }
+        if (!namespace.writeSQL(sqlId, connection))
+        { return false;
+	}
+      }
+    }
+    return true;
+  }
+
+  public static METSDescriptive readSQL(DocumentInterface document, GS3SQLConnection connection,
+					ResultSet resultSet)
+  {
+    try {
+      String ID   = resultSet.getString("MetaID");
+      String name = resultSet.getString("GroupID");
+
+      // create the metadata block object
+      METSDescriptive descriptive = new METSDescriptive(ID, name);
+      
+      // get its metadata reference to retrieve namespaces
+      int metadataRef = resultSet.getInt("MetadataRef");
+
+      // query the database for matching namespaces for this metadata block
+      GS3SQLSelect select = new GS3SQLSelect("namespaces");
+      select.addField("*");
+      GS3SQLWhereItem whereItem = new GS3SQLWhereItem("MetadataRef", "=", Integer.toString(metadataRef),
+						      GS3SQLField.INTEGER_TYPE);
+      GS3SQLWhere where = new GS3SQLWhere(whereItem);
+      select.setWhere(where);
+
+      connection.execute(select.toString());
+
+      // parse through the namespaces, calling the namespace class to create instances
+      // as it will
+      ResultSet namespaceSet = connection.getResultSet();
+      if (namespaceSet != null && namespaceSet.first()) {
+	do {
+	  METSNamespace namespace = METSNamespace.readSQL(connection, namespaceSet);
+	  if (namespace != null) {
+	    descriptive.addNamespace(namespace);
+	  }
+	  else {
+	    System.out.println("Null namespace output");
+	  }
+	}
+	while (namespaceSet.next());
+      }
+
+      return descriptive;
+    }
+    catch (SQLException sqlEx)
+    { System.out.println(sqlEx);
+      System.exit(1);
+    }
+    return null;
   }
 }
Index: /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSDescriptiveSet.java
===================================================================
--- /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSDescriptiveSet.java	(revision 5944)
+++ /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSDescriptiveSet.java	(revision 5945)
@@ -7,4 +7,7 @@
 import java.util.Map;
 import java.util.Iterator;
+
+import java.sql.SQLException;
+import java.sql.ResultSet;
 
 import org.w3c.dom.Document;
@@ -18,14 +21,16 @@
 import org.xml.sax.SAXParseException;
 
-
 import org.greenstone.gsdl3.gs3build.doctypes.DocumentInterface;
 
 import org.greenstone.gsdl3.gs3build.util.GS3SQLConnection;
+import org.greenstone.gsdl3.gs3build.database.*;
 
 public class METSDescriptiveSet
 { Map children;
+  Map childrenById;
 
   public METSDescriptiveSet()
   { this.children = new HashMap();
+    this.childrenById = new HashMap();
 
     METSDescriptive descriptive = new METSDescriptive("DM1", "default");
@@ -35,8 +40,13 @@
   public void addDescriptive(METSDescriptive metadata)
   { this.children.put(metadata.getName(), metadata);
+    this.childrenById.put(metadata.getID(), metadata);
   }
 
   public METSDescriptive getDescriptive(String name)
   { return (METSDescriptive) this.children.get(name);
+  }
+
+  public METSDescriptive getDescriptiveById(String id)
+  { return (METSDescriptive) this.childrenById.get(id);
   }
 
@@ -101,5 +111,5 @@
 
 
-  public void writeSQL(DocumentInterface document, GS3SQLConnection connection)
+  public boolean writeSQL(DocumentInterface document, GS3SQLConnection connection)
   { Iterator groups = this.children.values().iterator();
     
@@ -107,6 +117,9 @@
     { METSDescriptive group = (METSDescriptive) groups.next();
 
-      group.writeSQL(document, connection);
+      if (!group.writeSQL(document, connection))
+      { return false;
+      }
     }
+    return true;
   }
 
@@ -122,4 +135,36 @@
     return set;
   }
+
+  public static METSDescriptiveSet readSQL(DocumentInterface document, GS3SQLConnection connection)
+  {
+    METSDescriptiveSet set = new METSDescriptiveSet();
+
+    GS3SQLSelect select = new GS3SQLSelect("metadata");
+    select.addField("*");
+    GS3SQLWhereItem whereItem = new GS3SQLWhereItem("DocID", "=", document.getID().toString());
+    select.setWhere(new GS3SQLWhere(whereItem));
+    connection.execute(select.toString());
+
+    // start going through the matching metadata blocks
+    try {
+      ResultSet resultSet = connection.getResultSet();
+      resultSet.first();
+      do {
+	METSDescriptive descriptive = METSDescriptive.readSQL(document, connection, resultSet);
+	if (descriptive != null) {
+	  set.addDescriptive(descriptive);
+	}
+	else {
+	  System.out.println("Null descriptive");
+	}
+      } while (resultSet.next());
+    }
+    catch (SQLException sqlEx) {
+      System.out.println(sqlEx);
+      System.exit(1);
+    }
+
+    return set;
+  }
 }
 
